#!/usr/bin/env python

from cms import CountMinSketch
import matplotlib.pyplot as plt; plt.rcdefaults()
import numpy as np
import matplotlib.pyplot as plt
import random

def keyboard_estimate (C,r):
    c = CountMinSketch (C,r)
    input_set = set ()
    x = 0
    while x != -1:
        x = input ("Add an element or type -1 ")
        if x != -1:
            input_set.add (x)
            c.add (x)
            print c
    print " elem  query CMM"
    for elem in input_set:
        print repr(elem).rjust (2), repr(c.query (elem)).rjust(5), repr (c.CMM (elem)).rjust (5)


def automatic_estimate (C, r, distinct, tot_elems, graph_cat=-1, skewness=True):
    c = CountMinSketch (C,r)
    elements = [0 for _ in range (distinct)]
    if skewness == True:
        coeffs = (np.random.pareto (3., distinct) + 1) * 2
        ratio = float (tot_elems) / sum (coeffs) 
        for i in range (distinct):
            elements[i] = int (coeffs[i] * ratio)
    else:
        for i in range (tot_elems):
            elements[random.randint (0, distinct - 1)] += 1

    elements.sort (reverse=True)

    if graph_cat == -1:  #  Reduces for visualization purposes
        graph_cat = distinct

    if skewness == True:
        m = min (elements) - 1
        for i in range (distinct):
            elements[i] -= random.randint (0,m)
        elements.sort (reverse=True)


    for i in range (len (elements)):
        c.add (i, elements[i])

    plt.axis([0, graph_cat + 2, 0, max (elements) + 5])
    y_pos = [float ((i+1) - 0.2) for i in range (graph_cat)]
    plt.bar (y_pos, elements[:graph_cat], 0.2, align='center', alpha=0.5)
    for i in range (graph_cat):
        y_pos[i] += 0.2 
    q = [c.query (i) for i in range (graph_cat)]
    plt.bar (y_pos, q, 0.2, align='center', alpha=0.5)

    print "id   elem  query  CMM"
    for i in range (graph_cat):
        print repr(i).rjust (2), repr(elements[i]).rjust (5), repr(c.query (i)).rjust(5), repr (c.CMM (i)).rjust (5)



def plot_estimate (C, r, distinct, tot_elems, graph_cat=-1, skewness=True):
    c = CountMinSketch (C,r)
    elements = [0 for _ in range (distinct)]
    if skewness == True:
        coeffs = (np.random.pareto (3., distinct) + 1) * 2
        ratio = float (tot_elems) / sum (coeffs) 
        for i in range (distinct):
            elements[i] = int (coeffs[i] * ratio)
    else:
        for i in range (tot_elems):
            elements[random.randint (0, distinct - 1)] += 1

    elements.sort (reverse=True)

    if graph_cat == -1:  #  Reduces for visualization purposes
        graph_cat = distinct

    if skewness == True:
        m = min (elements) - 1
        for i in range (distinct):
            elements[i] -= random.randint (0,m)
        elements.sort (reverse=True)


    for i in range (len (elements)):
        c.add (i, elements[i])

    plt.axis([0, graph_cat + 2, 0, max (elements) + 5])
    y_pos = [float ((i+1) - 0.2) for i in range (graph_cat)]
    plt.bar (y_pos, elements[:graph_cat], 0.2, align='center', alpha=0.5)
    for i in range (graph_cat):
        y_pos[i] += 0.2 
    q = [c.query (i) for i in range (graph_cat)]
    plt.bar (y_pos, q, 0.2, align='center', alpha=0.5)

    for i in range (graph_cat):
        y_pos[i] += 0.2 
    q = [c.CMM (i) for i in range (graph_cat)]
    plt.bar (y_pos, q, 0.2, align='center', alpha=0.5)

    plt.show()

if __name__ == "__main__":
    # keyboard_estimate (10, 5)
    #  Params C,r,distinct,tot,subplot,skew
    #plot_estimate (150, 25, 1000, 80000, 20, False)
    #plot_estimate (150, 25, 1000, 80000, 20, True)
    #plot_estimate (150, 25, 1500, 80000, 20, True)
    #plot_estimate (150, 25, 3750, 80000, 20, True)
    #plot_estimate (150, 25, 8000, 80000, 20, True)
    #plot_estimate (150, 25, 16000, 80000, 20, True)
    #plot_estimate (150, 25, 24000, 160000, 20, True)
    automatic_estimate (150, 25, 24000, 160000, 20, True)

    #plot_estimate (150, 25, 2400, 10000, 10, True)
    #plot_estimate (150, 25, 240, 1600, 20, True)
